
#include <stdlib.h>
#include <stdio.h>
#include <gsl/gsl_rng.h>
#include <gsl/gsl_randist.h>
#include <string.h>
#include <math.h>
#include <errno.h>
//include the path here to Mygsl.h
#include </opt/csound516/Mygsl.h>

double Mygsl_rhy_dists(int distribnumber, int counter, const gsl_rng * r)
{
    double uu; //the function's double return value
    unsigned int yy;
    int distribution = distribnumber;
    int distcounter = counter;

//****************************************
//********  GSL DISTRIBTUIONS    *********
//****************************************
//the following distributions return type double

    if (distribution == 1)
    {
        if (distcounter == 1)
        {
            printf("\n\t\t\tGAUSSIAN(GSL) DISTRIBUTION\n");
            printf("\t\t\t***** RHYTHM *****");
            printf("\n");
            printf("Enter a double value for sigma, Ex. (0.65): ");
            scanf("%lf",&sigma);
            uu = gsl_ran_gaussian (r, sigma);
        }
        else
        {
            gsl_ran_gaussian (r, sigma);
            uu = gsl_ran_gaussian (r, sigma);
        }
    }

    if (distribution == 2)
    {
        if (distcounter == 1)
        {
            printf("\n\t\t\tGAUSSIAN_TAIL(GSL) DISTRIBUTION\n");
            printf("\t\t\t***** RHYTHM *****");
            printf("\n");
            printf("Enter a value for 'a' and sigma,\
                   \nwhere 'a' is positive, Ex. (0.45, 0.65): ");
            scanf("%lf, %lf",&a, &sigma);
            uu = gsl_ran_gaussian_tail (r, a, sigma);
        }
        else
        {
            uu = gsl_ran_gaussian_tail (r, a, sigma);
        }
    }

    if (distribution == 3)
    {
        if (distcounter == 1)
        {
            printf("\n\t\t\tEXPONENTIAL(GSL) DISTRIBUTION\n");
            printf("\t\t\t***** RHYTHM *****");
            printf("\n");
            printf("Enter a double value for mu, Ex. (0.65): ");
            scanf("%lf",&mu);
            uu = gsl_ran_exponential (r, mu);
        }
        else
        {
            uu = gsl_ran_exponential (r, mu);
        }
    }

    if (distribution == 4)
    {
        if (distcounter == 1)
        {
            printf("\n\t\t\tLAPLACE(GSL) DISTRIBUTION\n");
            printf("\t\t\t***** RHYTHM *****");
            printf("\n");
            printf("Enter a double value for 'a', Ex. (0.65): ");
            scanf("%lf",&a);
            uu = gsl_ran_laplace (r, a);
        }
        else
        {
            gsl_ran_laplace (r, a);  //additional call to avoid nan error
            uu = gsl_ran_laplace (r, a);
        }
    }

    if (distribution == 5)
    {
        if (distcounter == 1)
        {
            printf("\n\t\t\tEXPPOW(GSL) DISTRIBUTION\n");
            printf("\t\t\t***** RHYTHM *****");
            printf("\n");
            //For b = 1 this reduces to the Laplace distribution.
            //For b = 2 it has the same form as a Gaussian distribution.
            printf("Enter a values for 'a' and 'b',\
                   \nwhere a and b are positive, Ex. (0.45, 0.65): ");
            scanf("%lf, %lf",&a, &b);
            uu = gsl_ran_exppow (r, a, b);
        }
        else
        {
            uu = gsl_ran_exppow (r, a, b);
        }
    }

    if (distribution == 6)
    {
        if (distcounter == 1)
        {
            printf("\n\t\t\tCAUCHY(GSL) DISTRIBUTION\n");
            printf("\t\t\t***** RHYTHM *****");
            printf("\n");
            printf("Enter a double value for 'a', Ex. (0.65): ");
            scanf("%lf",&a);
            uu = gsl_ran_cauchy (r, a);
        }
        else
        {
            uu = gsl_ran_cauchy (r, a);
        }
    }

    if (distribution == 7)
    {
        if (distcounter == 1)
        {
            printf("\n\t\t\tRAYLEIGH(GSL) DISTRIBUTION\n");
            printf("\t\t\t***** RHYTHM *****");
            printf("\n");
            printf("Enter a double value for sigma, Ex. (0.65): ");
            scanf("%lf",&sigma);
            uu = gsl_ran_rayleigh (r, sigma);
        }
        else
        {
            gsl_ran_rayleigh (r, sigma); //additional call to avoid nan error
            uu = gsl_ran_rayleigh (r, sigma);
        }
    }

    if (distribution == 8)
    {
        if (distcounter == 1)
        {
            printf("\n\t\t\tRAYLEIGH_TAIL(GSL) DISTRIBUTION\n");
            printf("\t\t\t***** RHYTHM *****");
            printf("\n");
            printf("Enter a value for 'a' and sigma,\
                   \nwhere 'a' is positive, Ex. (0.45, 0.65): ");
            scanf("%lf, %lf",&a, &sigma);
            uu = gsl_ran_rayleigh_tail (r, a, sigma);
        }
        else
        {
            uu = gsl_ran_rayleigh_tail (r, a, sigma);
        }
    }

    if (distribution == 9)  //returned pdfs are quite low for this dist
    {
        if (distcounter == 1)
        {
            printf("\n\t\t\tLANDAU(GSL) DISTRIBUTION\n");
            printf("\t\t\t***** RHYTHM *****");
            printf("\n");
            uu = gsl_ran_landau (r);
        }
        else
        {
            uu = gsl_ran_landau (r);
        }
    }

    if (distribution == 10)
    {
        if (distcounter == 1)
        {
            printf("\n\t\t\tLEVY(GSL) DISTRIBUTION\n");
            printf("\t\t\t***** RHYTHM *****");
            printf("\n");
            printf("Enter a value for 'c' and alpha,\
                   \nwhere 0<alpha<=2, Ex. (0.65, 1.0): ");
            scanf("%lf, %lf",&c, &alpha);
            uu = gsl_ran_levy (r, c, alpha);
        }
        else
        {
            uu = gsl_ran_levy (r, c, alpha);
        }
    }

    if (distribution == 11)
    {
        if (distcounter == 1)
        {
            printf("\n\t\t\tLEVY_SKEW(GSL) DISTRIBUTION\n");
            printf("\t\t\t***** RHYTHM *****");
            printf("\n");
            printf("Enter a value for 'c', alpha, and beta\
                   \nwhere 0<alpha<=2, Ex. (0.65, 1.0, 0.43): ");
            scanf("%lf, %lf, %lf",&c, &alpha, &beta);
            uu = gsl_ran_levy_skew (r, c, alpha, beta);

        }
        else
        {
            uu = gsl_ran_levy_skew (r, c, alpha, beta);
        }
    }

    if (distribution == 12)
    {
        if (distcounter == 1)
        {
            printf("\n\t\t\tGAMMA(GSL) DISTRIBUTION\n");
            printf("\t\t\t***** RHYTHM *****");
            printf("\n");
            printf("Enter a value for 'a' and 'b',\
                   \nEx. (1.0, 0.65): ");
            scanf("%lf, %lf",&a, &b);
            uu = gsl_ran_gamma (r, a, b);
        }
        else
        {
            uu = gsl_ran_gamma (r, a, b);
        }
    }

    if (distribution == 13)
    {
        if (distcounter == 1)
        {
            printf("\n\t\t\tFLAT(normal)(GSL) DISTRIBUTION\n");
            printf("\t\t\t***** RHYTHM *****");
            printf("\n");
            printf("Enter a value for 'a' and 'b',\
                   \nEx. (0.45, 0.65): ");
            scanf("%lf, %lf",&a, &b);
            uu = gsl_ran_flat (r, a, b);
        }
        else
        {
            uu = gsl_ran_flat (r, a, b);
        }
    }

    if (distribution == 14)
    {
        if (distcounter == 1)
        {
            printf("\n\t\t\tLOGNORMAL(GSL) DISTRIBUTION\n");
            printf("\t\t\t***** RHYTHM *****");
            printf("\n");
            printf("Enter values for 'zeta' and 'sigma',\
                   \nEx. (0.45, 0.65): ");
            scanf("%lf, %lf",&zeta, &sigma);
            uu = gsl_ran_lognormal (r, zeta, sigma);
        }
        else
        {
            uu = gsl_ran_lognormal (r, zeta, sigma);
        }
    }

    if (distribution == 15)
    {
        if (distcounter == 1)
        {
            printf("\n\t\t\tCHISQ(GSL) DISTRIBUTION\n");
            printf("\t\t\t***** RHYTHM *****");
            printf("\n");
            printf("Enter a double value for nu, Ex. (0.65): ");
            scanf("%lf",&nu);
            uu = gsl_ran_chisq (r, nu);
        }
        else
        {
            uu = gsl_ran_chisq (r, nu);
        }
    }

    if (distribution == 16)
    {
        if (distcounter == 1)
        {
            printf("\n\t\t\tF-(GSL) DISTRIBUTION\n");
            printf("\t\t\t***** RHYTHM *****");
            printf("\n");
            printf("Enter values for 'nu1' and 'nu2',\
                   \nEx. (1.50, 0.75): ");
            scanf("%lf, %lf",&nu1, &nu2);
            uu = gsl_ran_fdist (r, nu1, nu2);

        }
        else
        {
            uu = gsl_ran_fdist (r, nu1, nu2);
        }
    }

    if (distribution == 17)
    {
        if (distcounter == 1)
        {
            printf("\n\t\t\tt-(GSL) DISTRIBUTION\n");
            printf("\t\t\t***** RHYTHM *****");
            printf("\n");
            printf("Enter a double value for nu, Ex. (0.65): ");
            scanf("%lf",&nu);
            uu = gsl_ran_tdist (r, nu);
        }
        else
        {
            uu = gsl_ran_tdist (r, nu);
        }
    }

    if (distribution == 18)
    {
        if (distcounter == 1)
        {
            printf("\n\t\t\tBETA(GSL) DISTRIBUTION\n");
            printf("\t\t\t***** RHYTHM *****");
            printf("\n");
            printf("Enter a value for 'a', and 'b'\
                   \nbetween 0 and 1, Ex. (0.65, 0.43): ");
            scanf("%lf, %lf",&a, &b);
            uu = gsl_ran_beta (r, a, b);
        }
        else
        {
            uu = gsl_ran_beta (r, a, b);
        }
    }

    if (distribution == 19)
    {
        if (distcounter == 1)
        {
            printf("\n\t\t\tLOGISTIC(GSL) DISTRIBUTION\n");
            printf("\t\t\t***** RHYTHM *****");
            printf("\n");
            printf("Enter a double value for 'a', Ex. (0.65): ");
            scanf("%lf",&a);
            uu = gsl_ran_logistic (r, a);
        }
        else
        {
            gsl_ran_logistic (r, a); //additional call to avoid nan error
            uu = gsl_ran_logistic (r, a);
        }
    }

    if (distribution == 20)
    {
        if (distcounter == 1)
        {
            printf("\n\t\t\tPARETO(GSL) DISTRIBUTION\n");
            printf("\t\t\t***** RHYTHM *****");
            printf("\n");
            printf("Enter a value for 'a', and 'b'\
                   \nEx. (0.65, 0.43): ");
            scanf("%lf, %lf",&a, &b);
            uu = gsl_ran_pareto (r, a, b);
        }
        else
        {
            uu = gsl_ran_pareto (r, a, b);
        }
    }

    if (distribution == 21)
    {
        if (distcounter == 1)
        {
            printf("\n\t\t\tWEIBULL(GSL) DISTRIBUTION\n");
            printf("\t\t\t***** RHYTHM *****");
            printf("\n");
            printf("Enter a value for 'a', and 'b'\
                   \nEx. (0.65, 0.43): ");
            scanf("%lf, %lf",&a, &b);
            uu = gsl_ran_weibull (r, a, b);
        }
        else
        {
            uu = gsl_ran_weibull (r, a, b);
        }
    }

    if (distribution == 22)
    {
        if (distcounter == 1)
        {
            printf("\n\t\t\tGUMBEL1(GSL) DISTRIBUTION\n");
            printf("\t\t\t***** RHYTHM *****");
            printf("\n");
            printf("Enter a value for 'a', and 'b'\
                   \nEx. (0.65, 0.43): ");
            scanf("%lf, %lf",&a, &b);
            uu = gsl_ran_gumbel1 (r, a, b);
        }
        else
        {
            uu = gsl_ran_gumbel1 (r, a, b);
        }
    }

    if (distribution == 23)
    {
        if (distcounter == 1)
        {
            printf("\n\t\t\tGUMBEL2(GSL) DISTRIBUTION\n");
            printf("\t\t\t***** RHYTHM *****");
            printf("\n");
            printf("Enter a value for 'a', and 'b'\
                   \nEx. (0.65, 0.43): ");
            scanf("%lf, %lf",&a, &b);
            uu = gsl_ran_gumbel2 (r, a, b);
        }
        else
        {
            uu = gsl_ran_gumbel2 (r, a, b);
        }
    }

    // The following discrete distribution types return unsigned int
    // but are converted to double by division of '1'.
    if (distribution == 24)
    {
        if (distcounter == 1)
        {
            printf("\n\t\t\tPOISSON(GSL) DISTRIBUTION\n");
            printf("\t\t\t***** RHYTHM *****");
            printf("\n");
            printf("Enter a double value for mu, Ex. (3.314): ");
            scanf("%lf",&mu);
            yy = gsl_ran_poisson (r, mu);
            uu = (double)1/(double)yy;
        }
        else
        {
            yy = gsl_ran_poisson (r, mu);
            uu = (double)1/(double)yy;
        }
    }

    if (distribution == 25)  //returns 0 or 1 !!!!!!!!!!!!!!!!!!!!!!
    {
        if (distcounter == 1)
        {
            printf("\n\t\t\tBINOMIAL(GSL) DISTRIBUTION\n");
            printf("\t\t\t***** RHYTHM *****");
            printf("\n");
            printf("Enter a double value for 'p',\
                   \nand an unsigned int (pos) value for 'n'\
                   \nwhere 'n' is the same as the highest midi\
                   \nnote value for a pitch\
                   \nEx. (0.25, 127): ");
            scanf("%lf, %u",&p, &n);
            yy = gsl_ran_binomial (r, p, n);
            uu = (double)1/(double)yy;
        }
        else
        {
            gsl_ran_binomial (r, p, n);
            yy = gsl_ran_binomial (r, p, n);
            uu = (double)1/(double)yy;
        }
    }

    if (distribution == 26)
    {
        if (distcounter == 1)
        {
            printf("\n\t\t\tNEGATIVE_BINOMIAL(GSL) DISTRIBUTION\n");
            printf("\t\t\t***** RHYTHM *****");
            printf("\n");
            printf("Enter a double value for 'p', and 'n'\
                   \nEx. (0.25, 0.50): ");
            scanf("%lf, %lf",&p, &nn);
            yy = gsl_ran_negative_binomial (r, p, nn);
            uu = (double)1/(double)yy;
        }
        else
        {
            yy = gsl_ran_negative_binomial (r, p, nn);
            uu = (double)1/(double)yy;
        }
    }

    if (distribution == 27)  //neg val in pdf is causing crash !!!!!!!!!!!!!!!!!!!!!!
    {
        if (distcounter == 1)
        {
            printf("\n\t\t\tPASCAL(GSL) DISTRIBUTION\n");
            printf("\t\t\t***** RHYTHM *****");
            printf("\n");
            printf("Enter a double value for 'p',\
                   \nand and unsigned int (pos) value for 'n'\
                   \nwhere 'n' is the same as the highest midi\
                   \nnote value for a pitch\
                   \nEx. (0.25, 127): ");
            scanf("%lf, %u",&p, &n);
            yy = gsl_ran_pascal (r, p, n);
            uu = (double)1/(double)yy;
        }
        else
        {
            yy = gsl_ran_pascal (r, p, n);
            uu = (double)1/(double)yy;
        }
    }

    if (distribution == 28)
    {
        if (distcounter == 1)
        {
            printf("\n\t\t\tGEOMETRIC(GSL) DISTRIBUTION\n");
            printf("\t\t\t***** RHYTHM *****");
            printf("\n");
            printf("Enter a double value for 'p', Ex. (0.50): ");
            scanf("%lf",&p);
            yy = gsl_ran_geometric (r, p);
            uu = (double)1/(double)yy;
        }
        else
        {
            yy = gsl_ran_geometric (r, p);
            uu = (double)1/(double)yy;
        }
    }

    if (distribution == 29)
    {
        if (distcounter == 1)
        {
            printf("\n\t\t\tHYPERGEOMETRIC(GSL) DISTRIBUTION\n");
            printf("\t\t\t***** RHYTHM *****");
            printf("\n");
            printf("Enter unsigned int (pos) values for 'n1','n2', and 't'.\
\nt <= n_1 + n_2. Range of randist is max(0,t-n_2), ..., min(t,n_1).\
\nEx. (10, 1, 3): ");
            scanf("%u, %u, %u",&n1, &n2, &t);
            yy = gsl_ran_hypergeometric (r, n1, n2, t);
            uu = (double)1/(double)yy;
        }
        else
        {
            yy = gsl_ran_hypergeometric (r, n1, n2, t);
            uu = (double)1/(double)yy;
        }
    }

    if (distribution == 30)
    {
        if (distcounter == 1)
        {
            printf("\n\t\t\tLOGARITHMIC(GSL) DISTRIBUTION\n");
            printf("\t\t\t***** RHYTHM *****");
            printf("\n");
            printf("Enter a double value for 'p', Ex. (0.99): ");
            scanf("%lf",&p);
            yy = gsl_ran_logarithmic (r, p);
            uu = (double)1/(double)yy;
        }
        else
        {
            yy = gsl_ran_logarithmic (r, p);
            uu = (double)1/(double)yy;
        }
    }

    return uu; //return type double
}
