#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <time.h>
#include <sys/time.h>

#define  MAX_LEVELS  300

int *pitchsort(int *thereturnarray, int numpitches)
{
    char c;
    char sortname[20];
    int *s, *sc; //local arrays sort, and sortcopy
    int h, i, x;
    int pitchnums, pitchsort;
    int transpnum, slotnum;
    char filepath[256];
    char pathappend[256];
    strcpy(filepath, "/opt/csound516");
    strcpy(pathappend, "/pitchsort.txt");
    strcat(filepath, pathappend);
    FILE *outf;
    pitchnums = numpitches - 1;

first:
    //***************************************
//*****  SELECT RANDOM DISTRIBUTION *****
//***************************************
    printf("\n");
    printf("\t\t\t***** SORT PITCHES *****");

    printf("\n1 = ascending, 2 = descending, 3 = retrograde, 4 = inverted\
            \n5 = retrograde inv, 6 = palindrome, 7 = transposition\
            \n8 = rotation, 9 = none(exit)\
     \n\nEnter a sort process for pitches:  ");
    scanf("%d",&pitchsort);

    s=(int*)calloc(1000,sizeof(int));/*pointer 's' is allocated 1000
				  integers and treated like an array */
    sc=(int*)calloc(1000,sizeof(int));/*pointer 'sc' is allocated 1000
				  integers and treated like an array */

//***************************************
//********  SORT LOOPS ***********
//***************************************

//**********************
//***** accending *****
//**********************
    if (pitchsort == 1)
    {
        strcpy(sortname, "ascending");
        printf("%s\n", sortname);

//load original pitch nums into local array 's'
        for (i=1; i<=pitchnums; i++)
        {
            s[i]=thereturnarray[i];
        }
//reference for this quicksort algorithm
//http://alienryderflex.com/quicksort/
//could have been done with GSL but this algo gives good results
        int  piv, beg[MAX_LEVELS], end[MAX_LEVELS], i=0, L, R, swap ;

//sort the local array 's'
        beg[0]=0;
        end[0]=pitchnums+1;
        while (i>=0)
        {
            L=beg[i];
            R=end[i]-1;
            if (L<R)
            {
                piv=s[L];
                while (L<R)
                {
                    while (s[R]>=piv && L<R) R--;
                    if (L<R) s[L++]=s[R];
                    while (s[L]<=piv && L<R) L++;
                    if (L<R) s[R--]=s[L];
                }
                s[L]=piv;
                beg[i+1]=L+1;
                end[i+1]=end[i];
                end[i++]=L;
                if (end[i]-beg[i]>end[i-1]-beg[i-1])
                {
                    swap=beg[i];
                    beg[i]=beg[i-1];
                    beg[i-1]=swap;
                    swap=end[i];
                    end[i]=end[i-1];
                    end[i-1]=swap;
                }
            }
            else
            {
                i--;
            }
        }
    } //end ascending

//**********************
//***** descending *****
//**********************
    if (pitchsort == 2)
    {
        strcpy(sortname, "descending");
        printf("%s\n", sortname);
        //load original pitch nums into local array 's'
        for (i=1; i<=pitchnums; i++)
        {
            s[i]=thereturnarray[i];
        }
//uses same quicksort algo from "ascending" sort
        int  piv, beg[MAX_LEVELS], end[MAX_LEVELS], i=0, L, R, swap ;

//sort the local array 's'
        beg[0]=0;
        end[0]=pitchnums+1;
        while (i>=0)
        {
            L=beg[i];
            R=end[i]-1;
            if (L<R)
            {
                piv=s[L];
                while (L<R)
                {
                    while (s[R]>=piv && L<R) R--;
                    if (L<R) s[L++]=s[R];
                    while (s[L]<=piv && L<R) L++;
                    if (L<R) s[R--]=s[L];
                }
                s[L]=piv;
                beg[i+1]=L+1;
                end[i+1]=end[i];
                end[i++]=L;
                if (end[i]-beg[i]>end[i-1]-beg[i-1])
                {
                    swap=beg[i];
                    beg[i]=beg[i-1];
                    beg[i-1]=swap;
                    swap=end[i];
                    end[i]=end[i-1];
                    end[i-1]=swap;
                }
            }
            else
            {
                i--;
            }
        }

        //'sc' becomes retrograde of sorted array 's'
        x = 1;
        for(i=pitchnums; i>=1; i--)
        {
            sc[x]= s[i];
            x++;
        }
        //loads retrograde back into 's'
        for (i=1; i<=pitchnums; i++)
        {
            s[i]= sc[i];
        }
    } //end descending

//**********************
//***** retrograde *****
//**********************
    if (pitchsort == 3)
    {
        strcpy(sortname, "retrograde");
        x = 1;
        for(i=pitchnums; i>=1; i--)
        {
            s[x]= thereturnarray[i];
            x++;
        }
    } //end retrograde

//**********************
//***** inverted *****
//**********************
    if (pitchsort == 4)
    {
//TODO if midi nums are > 127, transpose by one octave
        strcpy(sortname, "inverted");
        printf("%s\n", sortname);

        //invert within the space of '12'
        for (i=1; i<=pitchnums; i++)
        {
            sc[i] = thereturnarray[i]-(thereturnarray[i]%12);
            s[i]= 12-((thereturnarray[i])%12);
            s[i] = s[i] + sc[i];
        }
    } //end inverted

//**********************
//***** retrograde inverted *****
//**********************
    if (pitchsort == 5)
    {
        strcpy(sortname, "retrograde inverted");
        printf("%s\n", sortname);

        //invert within the space of '12'
        for (i=1; i<=pitchnums; i++)
        {
            sc[i] = thereturnarray[i]-(thereturnarray[i]%12);
            s[i]= 12-((thereturnarray[i])%12);
            s[i] = s[i] + sc[i];
        }
        //'sc' becomes retrograde of inverted array 's'
        x = 1;
        for(i=pitchnums; i>=1; i--)
        {
            sc[x]= s[i];
            x++;
        }
        //loads retrograde back into 's'
        for (i=1; i<=pitchnums; i++)
        {
            s[i]= sc[i];
        }
    } //end retrograde inverted

//**********************
//***** palindrome *****
//**********************
//Not a true palindrom. Only ascending and descending.
    if (pitchsort == 6)
    {
        strcpy(sortname, "palindrome");
        printf("%s\n", sortname);

//load original pitch nums into local array 's'
        for (i=1; i<=pitchnums; i++)
        {
            s[i]=thereturnarray[i];
        }

//same quicksort algo as above
        int  piv, beg[MAX_LEVELS], end[MAX_LEVELS], i=0, L, R, swap ;

//sort the local array 's'
        beg[0]=0;
        end[0]=pitchnums+1;
        while (i>=0)
        {
            L=beg[i];
            R=end[i]-1;
            if (L<R)
            {
                piv=s[L];
                while (L<R)
                {
                    while (s[R]>=piv && L<R) R--;
                    if (L<R) s[L++]=s[R];
                    while (s[L]<=piv && L<R) L++;
                    if (L<R) s[R--]=s[L];
                }
                s[L]=piv;
                beg[i+1]=L+1;
                end[i+1]=end[i];
                end[i++]=L;
                if (end[i]-beg[i]>end[i-1]-beg[i-1])
                {
                    swap=beg[i];
                    beg[i]=beg[i-1];
                    beg[i-1]=swap;
                    swap=end[i];
                    end[i]=end[i-1];
                    end[i-1]=swap;
                }
            }
            else
            {
                i--;
            }
        }
        //'sc' becomes retrograde of sorted array 's'
        x = 1;
        for(i=pitchnums; i>=1; i--)
        {
            sc[x]= s[i];
            x++;
        }
        //adds retrograde to end of 's'
        for (i=x; i<= (pitchnums + (x-1)); i++)
        {
            s[i]= sc[i-pitchnums];
        }
        //selects the pitches based on modulo
        h=1;
        for (i=1; i<= (pitchnums+(x-1)); i++)
        {
            if (i % 2 == 0 && i <= pitchnums)
            {
                sc[h] = s[i];
                h++;
            }
            if (i % 2 == 0 && i > pitchnums)
            {
                sc[h] = s[i];
                h++;
            }
        }
        //copies sc back to s for output, below
        for(i=1; i<=pitchnums; i++)
        {
            s[i] = sc[i];
        }

        //zeros the above retrograde added numbers
        //so main.c sees the zeros when counting
        for(i=pitchnums; i<= (pitchnums+(x-1)); i++)
        {
            if (i > pitchnums)
            {
                s[i] = 0;
            }
        }

    } //end of palindrome

//**********************
//***** transposition *****
//**********************
    if (pitchsort == 7)
    {
        strcpy(sortname, "transposition");
        printf("%s\n", sortname);
        printf("Enter a transposition number(ex. +1, or -1): ");
        scanf("%d",&transpnum);

        for (i=1; i<=pitchnums; i++)
        {
            s[i]= thereturnarray[i] + (transpnum);
        }
    } //end transposition

//**********************
//***** rotation *****
//**********************
    if (pitchsort == 8)
    {
        strcpy(sortname, "rotation");
        printf("%s\n", sortname);

        for (i=1; i<=pitchnums; i++)
        {
            printf(" %d:[%d] ", i,thereturnarray[i]);
        }

        printf("\n\nEnter a slot number for rotation (ex. 5): ");
        scanf("%d",&slotnum);

        for (i=1; i<=pitchnums; i++)
        {
            x=(i-1)+slotnum;
            if (x>pitchnums)
            {
                s[i]= thereturnarray[x-pitchnums];
            }
            else
                s[i]= thereturnarray[(i-1)+slotnum];
        }
    } //end rotation

//**********************
//***** none *****
//**********************
    if (pitchsort == 9)
    {
        strcpy(sortname, "none");
        printf("%s\n", sortname);

        for (i=1; i<=pitchnums; i++)
        {
            printf(" %d ", thereturnarray[i]);
        }

        for (i=1; i<=pitchnums; i++)
        {
            s[i]= thereturnarray[i];
        }
    } //end none

//***************************************
//********  PRINT PITCHES ***********
//***************************************
closing:
    printf("\n...from pitchsort.c\n");
    printf("original\n");
    for (x=1; x<=pitchnums; x++)
    {
        printf("%4d",thereturnarray[x]);/*prints numbers */
    }
    printf("\n%s\n", sortname);
    for (x=1; x<=pitchnums; x++)
    {
        printf("%4d",s[x]);/*prints numbers */
    }
    printf("\n");

//****************************************
//********  User Switch to resort using sorted *****
//****************************************

userswitch1:
    //printf("\n");
    printf("\nResort using %s?  (y)es, (n)o: ", sortname);
    while (getchar()!='\n');
    scanf("%c", &c);
    switch(c)
    {
    case 'y':
        for (i=1; i<=pitchnums; i++)
        {
            thereturnarray[i] = s[i];
        }
        free(s); //free memory
        free(sc);
        goto first;

    case 'n':
        goto resortno;
    default:
        //break;
        printf("\n...enter (y)es, or (n)o: \n");
        goto userswitch1;
    } //ends switch
resortno:

//****************************************
//** User Switch to save to keep original or sorted series **
// (contains old code to save series to text file)
//****************************************
userswitch2:
    //printf("\n");
    printf("\nKeep original, or %s? (o)riginal, (s)orted: ", sortname);
    while (getchar()!='\n');
    scanf("%c", &c);
    switch(c)
    {
//    case 't':
//    //printf("\n...Saving to filepath: %s\n", filepath);
//        if((outf = fopen(filepath, "w")) != NULL)
//        {
//            fprintf(outf, "\n...from pitchsort.c\n");
//            fprintf(outf, "original\n");
//            for (x=1; x<=pitchnums; x++)
//            {
//                fprintf(outf, "%4d",thereturnarray[x]);/*prints numbers */
//            }
//            fprintf(outf, "\n%s\n", sortname);
//            for (x=1; x<=pitchnums; x++)
//            {
//                fprintf(outf, "%4d",s[x]);/*prints numbers */
//            }
//        printf("File saved to:");
//        printf("%s\n", filepath);
//        }
//        else
//        {
//            printf("May need to set correct file path in pitchsort.c");
//        }
//        fclose(outf);
//        goto closing;
    case 'o':
        for (x=1; x<=pitchnums; x++)
        {
            s[x] = thereturnarray[x];
        }
        free(sc);
        goto last;
    case 's':
        for (i=1; i<=pitchnums; i++)
        {
            thereturnarray[i] = s[i];
        }
        for (i=1; i<=pitchnums; i++)
        {
            s[i] = thereturnarray[i];
        }
        free(sc);
        goto last;
    default:
        //break;
        printf("\n...enter (s)orted, or (o)riginal: \n");
        goto userswitch2;
    } //ends switch
last:

    return s;
} //ends pitchsort.c

